#include <iostream>
#include <vector>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
}

Input input_data() {

    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    Input in;

    cout << "Enter bin count: ";
    cin >> in.bin_count;

    in.numbers.resize(number_count);
    in.bin_count.resize(bin_count);

    cerr << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    return in;
}

void find_minmax(const vector<double> &numbers, double &min, double &max){
    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}

int main(){
    Input in = input_data();

    vector<size_t> bins ( in.bin_count );
    double min = in.numbers[0];
    double max = in.numbers[0];

    find_minmax(in.numbers, min, max);

    double bin_size = (max - min) / in.bin_count;

    for (size_t i = 0; i < in.number.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < (in.bin_count - 1)) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= in.numbers[i]) && (in.numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[in.bin_count - 1]++;
        }
    }

    size_t maxbin = bins[0];
    for (size_t i=1; i < in.bin_count; i++){
        if (maxbin < bins[i]){
            maxbin = bins[i];
        }
    }

    if (maxbin <= MAX_ASTERISK){
        for (size_t i = 0; i < in.bin_count; i++) {
            cout.width(4);
            cout << bins[i] << "|";
            for (size_t j = 0; j < bins[i]; j++) {
                cout << "*";
            }
            cout << endl;
        }
        return 0;
    } else {
        for (size_t i = 0; i < in.bin_count; i++) {
            cout.width(4);
            cout << bins[i] << "|";
            size_t height = static_cast<size_t>(MAX_ASTERISK * (static_cast<double>(bins[i]) / maxbin));
            for (size_t j = 0; j < height; j++) {
                cout << "*";
            }
            cout << endl;
        }
        return 0;
    }
}
